/**
 * Should fetch autosuggestions from your AI
 * of choice. If there are no suggestions,
 * you should return an empty string.
 */
export type SuggestionRequestCallback = (prefix: string, suffix: string) => Promise<string>;
/**
 * Configure the UI, state, and keymap to power
 * auto suggestions, with an abstracted
 * fetch method.
 */
export declare const inlineCopilot: (onSuggestionRequest: SuggestionRequestCallback, delay?: number, acceptOnClick?: boolean) => (import("@codemirror/state").StateField<{
    suggestion: string | null;
}> | import("@codemirror/state").Extension)[];
export declare const clearLocalCache: () => void;
