var S = Object.defineProperty;
var C = (n, e, t) => e in n ? S(n, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : n[e] = t;
var a = (n, e, t) => (C(n, typeof e != "symbol" ? e + "" : e, t), t);
import { ViewPlugin as d, Decoration as u, keymap as y, WidgetType as F } from "@codemirror/view";
import { StateField as k, StateEffect as D, Facet as P, Prec as E, EditorSelection as f } from "@codemirror/state";
import { debouncePromise as T } from "./lib/utils.js";
const g = k.define({
  create() {
    return { suggestion: null };
  },
  update(n, e) {
    const t = e.effects.find(
      (s) => s.is(h)
    );
    if (e.state.doc) {
      if (t && e.state.doc == t.value.doc)
        return { suggestion: t.value.text };
      if (!e.docChanged && !e.selection)
        return n;
    }
    return { suggestion: null };
  }
}), h = D.define();
function O(n, e) {
  const t = n.state.selection.main.head, s = [], o = u.widget({
    widget: new b(e),
    side: 1
  });
  return s.push(o.range(t)), u.set(s);
}
const l = P.define({
  combine(n) {
    var e, t;
    return {
      acceptOnClick: !!((e = n.at(-1)) != null && e.acceptOnClick),
      fetchFn: (t = n.at(-1)) == null ? void 0 : t.fetchFn
    };
  }
});
class b extends F {
  /**
   * Create a new suggestion widget.
   */
  constructor(t) {
    super();
    a(this, "suggestion");
    this.suggestion = t;
  }
  toDOM(t) {
    const s = document.createElement("span");
    return s.style.opacity = "0.4", s.className = "cm-inline-suggestion", s.textContent = this.suggestion, s.onclick = (o) => this.accept(o, t), s;
  }
  accept(t, s) {
    var c;
    if (!s.state.facet(l).acceptOnClick)
      return;
    t.stopPropagation(), t.preventDefault();
    const i = (c = s.state.field(g)) == null ? void 0 : c.suggestion;
    return i ? (s.dispatch({
      ...m(
        s.state,
        i,
        s.state.selection.main.head,
        s.state.selection.main.head
      )
    }), !0) : !1;
  }
}
const x = d.fromClass(
  class {
    constructor() {
      a(this, "cancelSuggestion", !1);
    }
    async update(e) {
      if (!e.docChanged) {
        e.selectionSet && (this.cancelSuggestion = !0);
        return;
      }
      this.cancelSuggestion = !1;
      const t = e.state.doc;
      if (e.transactions.some(
        (c) => c.isUserEvent("input.complete")
      ))
        return;
      const o = e.view.state.facet(l);
      if (!o.fetchFn) {
        console.error(
          "Unexpected issue in codemirror-copilot: fetchFn was not configured"
        );
        return;
      }
      const i = await o.fetchFn(e.state);
      this.cancelSuggestion || e.view.dispatch({
        effects: h.of({ text: i, doc: t })
      });
    }
  }
), I = d.fromClass(
  class {
    constructor() {
      a(this, "decorations");
      this.decorations = u.none;
    }
    update(e) {
      var s;
      const t = (s = e.state.field(g)) == null ? void 0 : s.suggestion;
      if (!t) {
        this.decorations = u.none;
        return;
      }
      this.decorations = O(
        e.view,
        t
      );
    }
  },
  {
    decorations: (n) => n.decorations
  }
), w = E.highest(
  y.of([
    {
      key: "Tab",
      run: (n) => {
        var t;
        const e = (t = n.state.field(g)) == null ? void 0 : t.suggestion;
        return e ? (n.dispatch({
          ...m(
            n.state,
            e,
            n.state.selection.main.head,
            n.state.selection.main.head
          )
        }), !0) : !1;
      }
    }
  ])
);
function m(n, e, t, s) {
  return {
    ...n.changeByRange((o) => {
      if (o == n.selection.main) {
        let r = 0;
        const p = ["]", "}", ")", ">", ";", '"', "'"];
        for (var i = 0; i < e.length; i++)
          p.includes(e[i]) && e[i] === n.sliceDoc(s + r, s + r + 1) && r++;
        return {
          changes: [
            { from: t, to: s, insert: e },
            { from: s, to: s + r }
          ],
          range: f.cursor(t + e.length)
        };
      }
      const c = s - t;
      return !o.empty || c && n.sliceDoc(o.from - c, o.from) != n.sliceDoc(t, s) ? { range: o } : {
        changes: { from: o.from - c, to: o.from, insert: e },
        range: f.cursor(o.from - c + e.length)
      };
    }),
    userEvent: "input.complete"
  };
}
function N(n) {
  const { delay: e = 500, acceptOnClick: t = !0 } = n, s = T(n.fetchFn, e);
  return [
    l.of({ acceptOnClick: t, fetchFn: s }),
    g,
    x,
    I,
    w
  ];
}
export {
  x as fetchSuggestion,
  N as inlineSuggestion,
  l as suggestionConfigFacet
};
//# sourceMappingURL=inline-suggestion.js.map
